package dMartinez;

import addbk.JAddressBook.IndexPanel;
import gui.run.RunMenuItem;
import net.web.UrlUtils;

import java.util.Vector;

public class LawyerDataMining {
    private IndexPanel indexPanel;
    private String lawyerType;
    private int state;


    public LawyerDataMining(IndexPanel indexPanel) {
        this.indexPanel = indexPanel;


    }

    public RunMenuItem getMenuItem() {
        return new scan4LawyersMenuItem();
    }


    public IndexPanel getIndexPanel() {
        return indexPanel;
    }

    public void setListingNum() {

        Vector v = UrlUtils.getUrlVector(LawyerSearchUtils.getUrlSource(getStateNum(), getLawyerType()));
        LawyerSearchUtils.findListingNum(v);
    }

    public int getStateNum() {
        return state;
    }

    public String getLawyerType() {
        return lawyerType;
    }

    private void setStateProperties(String s, String l) {
        //set state number
        for (int i = 0; i < In2.getStates().length; i++) {
            if (s.equals(In2.getStates()[i])) {
                state = i + 1;
                System.out.println("State(" + state + ")= " + In2.getStates()[i]);
            }
        }
        //set lawyer Type
        for (int i = 0; i < In2.getLawyerTypes().length; i++) {
            if (l.equals(In2.getLawyerTypes()[i])) {
                lawyerType = In2.getLawyerTypesRefNum()[i];
                System.out.println("LawyerType(" + lawyerType + ")=" + In2.getLawyerTypes()[i]);
            }
        }
    }

    private class scan4LawyersMenuItem extends RunMenuItem {
        public scan4LawyersMenuItem() {
            super("Scan Lawyers...");
        }

        public void run() {
            String state = In2.getState();
            String lawyerType = In2.getLawyerType();
            setStateProperties(state, lawyerType);
            LawyerSearchUtils.scanForLawyers(getStateNum(), getLawyerType());
        }
    }
}
